Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm	(revision 34921)
@@ -852,9 +1159,86 @@
         },
     ],
-    0x000e => { #7
+    0x000e => [{ #29
         Name => 'AFPointSelected',
+        Condition => '$$self{Model} =~ /K-1\b/',
         Writable => 'int16u',
+        Notes => 'K-1',
         PrintConvColumns => 2,
-        PrintConv => {
+        PrintConv => [{
+            0xffff => 'Auto',
+            0xfffe => 'Fixed Center',
+            0xfffd => 'Automatic Tracking AF', #JD
+            0xfffc => 'Face Detect AF', #JD
+            0xfffb => 'AF Select', #PH (Q select from 25-areas)
+            # AF pattern:
+            #       01 02 03 04 05
+            #    06 07 08 09 10 11 12
+            # 13 14 15 16 17 18 19 20 21
+            #    22 23 24 25 26 27 28
+            #       29 30 31 32 33
+            0 => 'None',
+            1 => 'Top-left',
+            2 => 'Top Near-left',
+            3 => 'Top',
+            4 => 'Top Near-right',
+            5 => 'Top-right',
+            6 => 'Upper Far-left',
+            7 => 'Upper-left',
+            8 => 'Upper Near-left',
+            9 => 'Upper-middle',
+            10 => 'Upper Near-right',
+            11 => 'Upper-right',
+            12 => 'Upper Far-right',
+            13 => 'Far Far Left',
+            14 => 'Far Left',
+            15 => 'Left',
+            16 => 'Near-left',
+            17 => 'Center',
+            18 => 'Near-right',
+            19 => 'Right',
+            20 => 'Far Right',
+            21 => 'Far Far Right',
+            22 => 'Lower Far-left',
+            23 => 'Lower-left',
+            24 => 'Lower Near-left',
+            25 => 'Lower-middle',
+            26 => 'Lower Near-right',
+            27 => 'Lower-right',
+            28 => 'Lower Far-right',
+            29 => 'Bottom-left',
+            30 => 'Bottom Near-left',
+            31 => 'Bottom',
+            32 => 'Bottom Near-right',
+            33 => 'Bottom-right',
+            263 => 'Zone Select Upper-left',       # 01,02;06,07,08;14,15,16
+            264 => 'Zone Select Upper Near-left',  # 01,02,03;07,08,09;15,16,17
+            265 => 'Zone Select Upper Middle',     # 02,03,04;08,09,10;16,17,18
+            266 => 'Zone Select Upper Near-right', # 03,04,05;09,10,11;17,18,19
+            267 => 'Zone Select Upper-right',      # 04,05;10,11,12;18,19,20
+            270 => 'Zone Select Far Left',         # 06,07;13,14,15;22,23
+            271 => 'Zone Select Left',             # 06,07,08;14,15,16;22,23,24
+            272 => 'Zone Select Near-left',        # 07,08,09;15,16,17;23,24,25
+            273 => 'Zone Select Center',           # 08,09,10;16,17,18;24,25,26
+            274 => 'Zone Select Near-right',       # 09,10,11;17,18,19;25,26,27
+            275 => 'Zone Select Right',            # 10,11,12;18,19,20;26,27,28
+            276 => 'Zone Select Far Right',        # 11,12;19,20,21;27,28
+            279 => 'Zone Select Lower-left',       # 14,15,16;22,23,24;29,30
+            280 => 'Zone Select Lower Near-left',  # 15,16,17;23,24,25;29,30,31
+            281 => 'Zone Select Lower-middle',     # 16,17,18;24,25,26;30,31,32
+            282 => 'Zone Select Lower Near-right', # 17,18,19;25,26,27;31,32,33
+            283 => 'Zone Select Lower-right',      # 18,19,20;26,27,28;32,33
+        },{
+            0 => 'Single Point',
+            1 => 'Expanded Area 9-point (S)',
+            3 => 'Expanded Area 25-point (M)',
+            5 => 'Expanded Area 33-point (L)',
+        }],
+    },{
+        Name => 'AFPointSelected',
+        Condition => '$$self{Model} =~ /K-3\b/',
+        Writable => 'int16u',
+        Notes => 'K-3',
+        PrintConvColumns => 2,
+        PrintConv => [{
             # 0 - Contrast-detect AF? - PH (K-5)
             0xffff => 'Auto',
@@ -862,4 +1246,86 @@
             0xfffd => 'Automatic Tracking AF', #JD
             0xfffc => 'Face Detect AF', #JD
+            0xfffb => 'AF Select', #PH (Q select from 25-areas)
+            # AF pattern: (ref forum5422)
+            #    01 02 03 04 05
+            #    06 07 08 09 10
+            # 11 12 13 14 15 16 17
+            #    18 19 20 21 22
+            #    23 24 25 26 27
+            0 => 'None',
+            1 => 'Top-left',
+            2 => 'Top Near-left',
+            3 => 'Top',
+            4 => 'Top Near-right',
+            5 => 'Top-right',
+            6 => 'Upper-left',
+            7 => 'Upper Near-left',
+            8 => 'Upper-middle',
+            9 => 'Upper Near-right',
+            10 => 'Upper-right',
+            11 => 'Far Left',
+            12 => 'Left',
+            13 => 'Near-left',
+            14 => 'Center',
+            15 => 'Near-right',
+            16 => 'Right',
+            17 => 'Far Right',
+            18 => 'Lower-left',
+            19 => 'Lower Near-left',
+            20 => 'Lower-middle',
+            21 => 'Lower Near-right',
+            22 => 'Lower-right',
+            23 => 'Bottom-left',
+            24 => 'Bottom Near-left',
+            25 => 'Bottom',
+            26 => 'Bottom Near-right',
+            27 => 'Bottom-right',
+            #forum5892
+            257 => 'Zone Select Top-left',
+            258 => 'Zone Select Top Near-left',
+            259 => 'Zone Select Top',
+            260 => 'Zone Select Top Near-right',
+            261 => 'Zone Select Top-right',
+            262 => 'Zone Select Upper-left',
+            263 => 'Zone Select Upper Near-left',
+            264 => 'Zone Select Upper-middle',
+            265 => 'Zone Select Upper Near-right',
+            266 => 'Zone Select Upper-right',
+            267 => 'Zone Select Far Left',
+            268 => 'Zone Select Left',
+            269 => 'Zone Select Near-left',
+            270 => 'Zone Select Center',
+            271 => 'Zone Select Near-right',
+            272 => 'Zone Select Right',
+            273 => 'Zone Select Far Right',
+            274 => 'Zone Select Lower-left',
+            275 => 'Zone Select Lower Near-left',
+            276 => 'Zone Select Lower-middle',
+            277 => 'Zone Select Lower Near-right',
+            278 => 'Zone Select Lower-right',
+            279 => 'Zone Select Bottom-left',
+            280 => 'Zone Select Bottom Near-left',
+            281 => 'Zone Select Bottom',
+            282 => 'Zone Select Bottom Near-right',
+            283 => 'Zone Select Bottom-right',
+        },{ #forum5892
+            0 => 'Single Point',
+            1 => 'Expanded Area 9-point (S)',
+            3 => 'Expanded Area 25-point (M)',
+            5 => 'Expanded Area 27-point (L)',
+        }],
+    },{ #7
+        Name => 'AFPointSelected',
+        Writable => 'int16u',
+        Notes => 'other models',
+        PrintConvColumns => 2,
+        PrintConv => [{
+            # 0 - Contrast-detect AF? - PH (K-5)
+            0xffff => 'Auto',
+            0xfffe => 'Fixed Center',
+            0xfffd => 'Automatic Tracking AF', #JD
+            0xfffc => 'Face Detect AF', #JD
+            0xfffb => 'AF Select', #PH (Q select from 25-areas)
+            0 => 'None', #PH (Q in manual focus mode)
             1 => 'Upper-left',
             2 => 'Top',
@@ -874,7 +1340,49 @@
             11 => 'Lower-right',
         },
-    },
-    0x000f => { #PH
+        # (second number exists for K-5II(s) is usually 0, but is 1 for AF.C with
+        # AFPointMode=='Select' and extended tracking focus points are enabled in the settings)
+        ],
+    }],
+    0x000f => [{ #PH
         Name => 'AFPointsInFocus',
+        Condition => '$$self{Model} =~ /K-3\b/',
+        Writable => 'int32u',
+        Notes => 'K-3 only',
+        PrintHex => 1,
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => {
+                0 => 'Top-left',
+                1 => 'Top Near-left',
+                2 => 'Top',
+                3 => 'Top Near-right',
+                4 => 'Top-right',
+                5 => 'Upper-left',
+                6 => 'Upper Near-left',
+                7 => 'Upper-middle',
+                8 => 'Upper Near-right',
+                9 => 'Upper-right',
+                10 => 'Far Left',
+                11 => 'Left',
+                12 => 'Near-left',
+                13 => 'Center',
+                14 => 'Near-right',
+                15 => 'Right',
+                16 => 'Far Right',
+                17 => 'Lower-left',
+                18 => 'Lower Near-left',
+                19 => 'Lower-middle',
+                20 => 'Lower Near-right',
+                21 => 'Lower-right',
+                22 => 'Bottom-left',
+                23 => 'Bottom Near-left',
+                24 => 'Bottom',
+                25 => 'Bottom Near-right',
+                26 => 'Bottom-right',
+            },
+        },
+    },{ #PH
+        Name => 'AFPointsInFocus',
+        Notes => 'other models',
         Writable => 'int16u',
         PrintHex => 1,
@@ -892,5 +1400,5 @@
             9 => 'Bottom-right',
         },
-    },
+    }],
     0x0010 => { #PH
         Name => 'FocusPosition',
@@ -956,4 +1464,16 @@
             32 => 40000, #PH
             33 => 51200, #PH
+            34 => 64000, #PH (NC)
+            35 => 80000, #PH (NC)
+            36 => 102400, #27
+            37 => 128000, #PH (NC)
+            38 => 160000, #PH (NC)
+            39 => 204800, #27
+            40 => 256000, #PH (NC)
+            41 => 320000, #PH (NC)
+            42 => 409600, #PH (NC)
+            43 => 512000, #PH (NC)
+            44 => 640000, #PH (NC)
+            45 => 819200, #PH (KP)
             # Optio 330/430 (oddball)
             50 => 50, #PH
@@ -986,4 +1506,14 @@
             277 => 36000, #PH
             278 => 51200, #PH
+            279 => 72000, #PH (NC)
+            280 => 102400, #PH (NC)
+            281 => 144000, #PH (NC)
+            282 => 204800, #PH (NC)
+            283 => 288000, #PH (NC)
+            284 => 409600, #PH (NC)
+            285 => 576000, #PH (NC)
+            286 => 819200, #PH (NC)
+            65534 => 'Auto 2', #PH (Q/Q10/Q7 MOV) [how is this different from 65535?]
+            65535 => 'Auto', #PH/31 (K-01/K-70 MP4)
         },
     },
@@ -995,9 +1525,14 @@
         Notes => q{
             calibrated differently for different models.  For the Optio WP, add 6 to get
-            approximate Light Value.  May not be valid for some models, ie. Optio S
-        },
-    },
-    0x0016 => { #PH
+            approximate Light Value.  May not be valid for some models, eg. Optio S
+        },
+    },
+    0x0016 => [{ #PH
         Name => 'ExposureCompensation',
+        Condition => '$count == 1',
+        Notes => q{
+            some models write two values here.  The second value is meaning of the
+            second value is not yet known
+        },
         Writable => 'int16u',
         ValueConv => '($val - 50) / 10',
@@ -1005,5 +1540,14 @@
         PrintConv => '$val ? sprintf("%+.1f", $val) : 0',
         PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
-    },
+    },{
+        Name => 'ExposureCompensation',
+        Writable => 'int16u',
+        # (2 values for K-70, etc -- have only seen "0" for the 2nd value - PH)
+        Count => 2,
+        ValueConv => '$val =~ s/ .*//; ($val - 50) / 10',
+        ValueConvInv => 'int($val * 10 + 50.5) . " 0"',
+        PrintConv => '$val ? sprintf("%+.1f", $val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    }],
     0x0017 => { #3
         Name => 'MeteringMode',
@@ -1026,10 +1570,25 @@
             '+1', '+2' or '+3' for step size
         },
-        # 1=.3ev, 2=.7, 3=1.0, ... 10=.5ev, 11=1.5, ...
-        ValueConv => [ '$val<10 ? $val/3 : $val-9.5' ],
-        ValueConvInv => [ 'abs($val-int($val)-.5)>0.05 ? int($val*3+0.5) : int($val+10)' ],
+        # 1=.3ev, 2=.7, 3=1.0 ... 10=.5, 11=1.5, ... 4096=0, 4097=0.5 ... 8192=0, 8193=0.3
+        # (models like K-1 and K-5 use 0x1000 and 0x2000 to indicate 1/2 and 1/3 EV step
+        # size -- convert this as a fraction so we can recognize this format when writing)
+        ValueConv => [ q{
+            return $val / 3 if $val < 10;
+            return $val - 9.5 if $val < 20;
+            return ($val - 0x1000) . '/2' if $val & 0x1000;
+            return ($val - 0x2000) . '/3' if $val & 0x2000;
+            return $val; # (shouldn't happen)
+        }],
+        ValueConvInv => [ q{
+            if ($val =~ s{/(\d+)$}{}) {
+                return $val + 0x1000 if $1 == 2;
+                return $val + 0x2000 if $1 == 3;
+                return undef;
+            }
+            return abs($val-int($val)-.5)>0.05 ? int($val*3+0.5) : int($val+10);
+        }],
         PrintConv => sub {
             my @v = split(' ', shift);
-            $v[0] = sprintf('%.1f', $v[0]) if $v[0];
+            $v[0] = sprintf('%.1f', $v[0]) if $v[0] and $v[0]!~m{/};
             if ($v[1]) {
                 my %s = (1=>'WB-BA',2=>'WB-GM',3=>'Saturation',4=>'Sharpness',
@@ -1077,4 +1636,6 @@
             9 => 'Flash', #13
             10 => 'Cloudy', #13
+            11 => 'Warm White Fluorescent', #PH (K-3)
+            14 => 'Multi Auto', #PH (K-3)
             15 => 'Color Temperature Enhancement', #PH
             17 => 'Kelvin', #PH
@@ -1152,13 +1713,13 @@
         PrintConvColumns => 2,
         PrintConv => [{ # the *istD has pairs of values - PH
-            0 => 'Low', #PH
-            1 => 'Normal', #PH
-            2 => 'High', #PH
-            3 => 'Med Low', #2
-            4 => 'Med High', #2
-            5 => 'Very Low', #(NC)
-            6 => 'Very High', #(NC)
-            7 => '-4', #PH (K-5)
-            8 => '+4', #PH (NC)
+            0 => '-2 (low)', #PH
+            1 => '0 (normal)', #PH
+            2 => '+2 (high)', #PH
+            3 => '-1 (medium low)', #2
+            4 => '+1 (medium high)', #2
+            5 => '-3 (very low)', #PH
+            6 => '+3 (very high)', #PH (NC)
+            7 => '-4 (minimum)', #PH (NC)
+            8 => '+4 (maximum)', #PH (K-5)
             65535 => 'None', #PH (Monochrome)
         }],
@@ -1171,13 +1732,14 @@
         PrintConvColumns => 2,
         PrintConv => [{ # the *istD has pairs of values - PH
-            0 => 'Low', #PH
-            1 => 'Normal', #PH
-            2 => 'High', #PH
-            3 => 'Med Low', #2
-            4 => 'Med High', #2
-            5 => 'Very Low', #PH
-            6 => 'Very High', #PH (NC)
-            7 => '-4', #PH (NC)
-            8 => '+4', #PH (K-5)
+            0 => '-2 (low)', #PH
+            1 => '0 (normal)', #PH
+            2 => '+2 (high)', #PH
+            3 => '-1 (medium low)', #2
+            4 => '+1 (medium high)', #2
+            5 => '-3 (very low)', #PH
+            6 => '+3 (very high)', #PH (NC)
+            7 => '-4 (minimum)', #PH (NC)
+            8 => '+4 (maximum)', #PH (K-5)
+            65535 => 'n/a', # got this for a Backlight Silhouette - PH (Q)
         }],
     },
@@ -1189,13 +1751,13 @@
         PrintConvColumns => 2,
         PrintConv => [{ # the *istD has pairs of values - PH
-            0 => 'Soft', #PH
-            1 => 'Normal', #PH
-            2 => 'Hard', #PH
-            3 => 'Med Soft', #2
-            4 => 'Med Hard', #2
-            5 => 'Very Soft', #(NC)
-            6 => 'Very Hard', #(NC)
-            7 => '-4', #PH (NC)
-            8 => '+4', #PH (NC)
+            0 => '-2 (soft)', #PH
+            1 => '0 (normal)', #PH
+            2 => '+2 (hard)', #PH
+            3 => '-1 (medium soft)', #2
+            4 => '+1 (medium hard)', #2
+            5 => '-3 (very soft)', #(NC)
+            6 => '+3 (very hard)', #(NC)
+            7 => '-4 (minimum)', #PH (NC)
+            8 => '+4 (maximum)', #PH (NC)
         }],
     },
@@ -1256,13 +1818,24 @@
     },
     # 0x002b - definitely exposure related somehow - PH
-    0x002d => { #PH
+    0x002d => [{ #PH
         Name => 'EffectiveLV',
+        Condition => '$format eq "int16u"',
         Notes => 'camera-calculated light value, but includes exposure compensation',
         Writable => 'int16u',
+        Format => 'int16s', # (negative values are valid even though Pentax writes int16u)
         ValueConv => '$val/1024',
         ValueConvInv => '$val * 1024',
         PrintConv => 'sprintf("%.1f",$val)',
         PrintConvInv => '$val',
-    },
+    },{
+        Name => 'EffectiveLV',
+        Condition => '$format eq "int32u"',
+        Writable => 'int32u',
+        Format => 'int32s',
+        ValueConv => '$val/1024',
+        ValueConvInv => '$val * 1024',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    }],
     0x0032 => { #13
         Name => 'ImageEditing',
@@ -1277,6 +1850,7 @@
             '2 0 0 0' => 'Cropped', #PH
             # note: doesn't apply to digital filters applied when picture is taken
-            '4 0 0 0' => 'Digital Filter 4', #PH (K10D)
+            '4 0 0 0' => 'Digital Filter 4', #PH (K10D, Ricoh WG-5)
             '6 0 0 0' => 'Digital Filter 6', #PH (K-5)
+            '8 0 0 0' => 'Red-eye Correction', #PH (WG-10)
             '16 0 0 0' => 'Frame Synthesis?',
         },
@@ -1310,7 +1884,14 @@
             '0 17' => 'Candlelight',
             '0 18' => 'Museum',
-            '0 19' => 'Food', #(n/c)
+            '0 19' => 'Food',
             '0 20' => 'Stage Lighting',
             '0 21' => 'Night Snap',
+            '0 23' => 'Blue Sky', # (Q)
+            '0 24' => 'Sunset', # (Q)
+            '0 26' => 'Night Scene HDR', # (Q)
+            '0 27' => 'HDR', # (Q)
+            '0 28' => 'Quick Macro', # (Q)
+            '0 29' => 'Forest', # (Q)
+            '0 30' => 'Backlight Silhouette', # (Q)
             # AUTO PICT modes (auto-selected)
             '1 4'  => 'Auto PICT (Standard)', #13
@@ -1335,4 +1916,5 @@
             '11 0' => 'Manual, Off-Auto-Aperture',
             '12 0' => 'Bulb, Off-Auto-Aperture',
+            '19 0' => 'Astrotracer', #29
             # extra K10D modes (ref 16)
             '13 0' => 'Shutter & Aperture Priority AE',
@@ -1344,7 +1926,13 @@
             '18 3' => 'Auto Program (MTF)', #PH (NC)
             '18 22' => 'Auto Program (Shallow DOF)', #PH (NC)
-            '254 0' => 'Video', #PH (K-7,K-5)
-            '255 0' => 'Video (Auto Aperture)', #PH (K-5)
-            '255 4' => 'Video (4)', #PH (K-x)
+            '20 22' => 'Blur Control', #PH (Q)
+            '249 0' => 'Movie (TAv)', #31
+            '250 0' => 'Movie (TAv, Auto Aperture)', #31
+            '251 0' => 'Movie (Manual)', #31
+            '252 0' => 'Movie (Manual, Auto Aperture)', #31
+            '253 0' => 'Movie (Av)', #31
+            '254 0' => 'Movie (Av, Auto Aperture)', #31
+            '255 0' => 'Movie (P, Auto Aperture)', #31
+            '255 4' => 'Video (4)', #PH (K-x,K-01)
         },{
             # EV step size (ref 19)
@@ -1358,14 +1946,15 @@
         Count => 4,
         PrintConv => [{
-            0 => 'Single-frame',
+            0 => 'Single-frame', # (also Interval Shooting for K-01 - PH)
             1 => 'Continuous', # (K-5 Hi)
             2 => 'Continuous (Lo)', #PH (K-5)
             3 => 'Burst', #PH (K20D)
+            4 => 'Continuous (Medium)', #PH (K-3)
             255 => 'Video', #PH (K-x)
-            # (K20D also has an Interval mode that needs decoding)
         },{
             0 => 'No Timer',
             1 => 'Self-timer (12 s)',
             2 => 'Self-timer (2 s)',
+            15 => 'Video', #PH (Q MOV)
             16 => 'Mirror Lock-up', # (K-5)
             255 => 'n/a', #PH (K-x)
@@ -1378,9 +1967,18 @@
             0x00 => 'Single Exposure',
             0x01 => 'Multiple Exposure',
+            0x02 => 'Composite Average', #31
+            0x03 => 'Composite Additive', #31
+            0x04 => 'Composite Bright', #31
+            0x08 => 'Interval Shooting', #31
+            0x0a => 'Interval Composite Average', #31
+            0x0b => 'Interval Composite Additive', #31
+            0x0c => 'Interval Composite Bright', #31
+            0x0f => 'Interval Movie', #PH (K-01)
             0x10 => 'HDR', #PH (645D)
             0x20 => 'HDR Strong 1', #PH (NC) (K-5)
             0x30 => 'HDR Strong 2', #PH (K-5)
             0x40 => 'HDR Strong 3', #PH (K-5)
-            0xe0 => 'HDR Auto', #PH (K-5)
+            0x50 => 'HDR Manual', #31 (K-70 HDR 1 and HDR 2)
+            0xe0 => 'HDR Auto', #PH (K-5, K-70)
             0xff => 'Video', #PH (K-x)
         }],
@@ -1394,5 +1992,5 @@
         #  11894 7962 (K10D,K-m)   12012 7987 (*istDS,K100D,K110D)   12012 8019 (*istD),
         #  12061 7988 (K-5)        12053 8005 (K-r,K-x)              14352 9535 (K20D,K-7)
-        #  22315 16711 (645)
+        #  22315 16711 (645)       12080 8008 (K-01)
         ValueConv => 'my @a=split(" ",$val); $_/=500 foreach @a; join(" ",@a)',
         ValueConvInv => 'my @a=split(" ",$val); $_*=500 foreach @a; join(" ",@a)',
@@ -1431,20 +2029,36 @@
         ValueConv => '$val & 0x7ff', # ignore other bits for now
         PrintConvColumns => 2,
-        PrintConv => { BITMASK => {
-            0 => 'Upper-left',
-            1 => 'Top',
-            2 => 'Upper-right',
-            3 => 'Left',
-            4 => 'Mid-left',
-            5 => 'Center',
-            6 => 'Mid-right',
-            7 => 'Right',
-            8 => 'Lower-left',
-            9 => 'Bottom',
-            10 => 'Lower-right',
-        } },
-    },
-    # 0x003d - int16u: 8192 for most images, but occasionally 11571 for K100D/K110D,
-    #              and 8289 or 8456 for the K-x - PH
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => {
+                0 => 'Upper-left',
+                1 => 'Top',
+                2 => 'Upper-right',
+                3 => 'Left',
+                4 => 'Mid-left',
+                5 => 'Center',
+                6 => 'Mid-right',
+                7 => 'Right',
+                8 => 'Lower-left',
+                9 => 'Bottom',
+                10 => 'Lower-right',
+            },
+        },
+    },
+    0x003d => { #IB
+        Name => 'DataScaling',
+        Writable => 'int16u',
+        # divide by the second value of Pentax_0x0201 (WhitePoint), usually
+        # 8192, to get the floating point normalization factor.
+        # One of the examples of how this tag can be used is calculation of
+        # baseline exposure compensation (Adobe-style) for a PEF:
+        # log2(Pentax_0x007e)-14-0.5+log2(Pentax_0x003d)-13
+        # or
+        # log2(Pentax_0x007e*(Pentax_0x003d/(2^13))/(2^14))-0.5
+        # where
+        # makernotes:Pentax_0x003d/(2^13) is the normalization factor. (ref IB)
+        # - 8192 for most images, but occasionally 11571 for K100D/K110D,
+        #   and 8289 or 8456 for the K-x (ref PH)
+    },
     0x003e => { #PH
         Name => 'PreviewImageBorders',
@@ -1454,12 +2068,6 @@
     },
     0x003f => { #PH
-        Name => 'LensType',
-        Writable => 'int8u',
-        Count => 2,
-        SeparateTable => 1,
-        # the K-m adds two zeros to the LensType, some other models add only 1
-        ValueConv => '$val=~s/^(\d+ \d+)( 0){1,2}$/$1/; $val',
-        ValueConvInv => '$val',
-        PrintConv => \%pentaxLensTypes,
+        Name => 'LensRec',
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::LensRec' },
     },
     0x0040 => { #PH
@@ -1476,5 +2084,5 @@
     },
     0x0047 => { #PH
-        Name => 'CameraTemperature',
+        Name => 'CameraTemperature', # (chassis temperature, ref forum6677)
         Writable => 'int8s',
         PrintConv => '"$val C"',
@@ -1494,6 +2102,7 @@
         PrintConv => { 0 => 'Off', 1 => 'On' },
     },
-    0x004d => { #PH
+    0x004d => [{ #PH
         Name => 'FlashExposureComp',
+        Condition => '$count == 1',
         Writable => 'int32s',
         ValueConv => '$val / 256',
@@ -1501,5 +2110,13 @@
         PrintConv => '$val ? sprintf("%+.1f", $val) : 0',
         PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
-    },
+    },{ #PH (K-3)
+        Name => 'FlashExposureComp',
+        Writable => 'int8s',
+        Count => 2,     # (don't know what the 2nd number is for)
+        ValueConv => [ '$val / 6' ],
+        ValueConvInv => [ '$val / 6' ],
+        PrintConv => [ '$val ? sprintf("%+.1f", $val) : 0' ],
+        PrintConvInv => [ 'Image::ExifTool::Exif::ConvertFraction($val)' ],
+    }],
     0x004f => { #PH
         Name => 'ImageTone', # (Called CustomImageMode in K20D manual)
@@ -1514,6 +2131,11 @@
             5 => 'Monochrome', # (K20D)
             6 => 'Muted', # (645D)
-            7 => 'Reversal Film', # (645D)
+            7 => 'Reversal Film', # (645D) (Ricoh WG-5 "Slide Film")
             8 => 'Bleach Bypass', # (K-5)
+            9 => 'Radiant', # (Q)
+            10 => 'Cross Processing', #31 (K-70)
+            11 => 'Flat', #31 (K-70)
+            # 256 - seen for GR III
+            # 262 - seen for GR III
         },
     },
@@ -1526,9 +2148,26 @@
     },
     # 0x0053-0x005a - not in JPEG images - PH
-    0x005c => { #PH
+    0x0053 => { #28
+        Name => 'ColorTempDaylight',
+        %colorTemp,
+        Notes => '0x0053-0x005a are 3 numbers: Kelvin, shift AB, shift GM',
+    },
+    0x0054 => { Name => 'ColorTempShade',        %colorTemp }, #28
+    0x0055 => { Name => 'ColorTempCloudy',       %colorTemp }, #28
+    0x0056 => { Name => 'ColorTempTungsten',     %colorTemp }, #28
+    0x0057 => { Name => 'ColorTempFluorescentD', %colorTemp }, #28
+    0x0058 => { Name => 'ColorTempFluorescentN', %colorTemp }, #28
+    0x0059 => { Name => 'ColorTempFluorescentW', %colorTemp }, #28
+    0x005a => { Name => 'ColorTempFlash',        %colorTemp }, #28
+    0x005c => [{ #PH
+        Name => 'ShakeReductionInfo',
+        Condition => '$count == 4', # (2 bytes for the K-3)
+        Format => 'undef', # (written as int8u) - do this just to save time converting the value
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::SRInfo' },
+    },{
         Name => 'ShakeReductionInfo',
         Format => 'undef', # (written as int8u) - do this just to save time converting the value
-        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::SRInfo' },
-    },
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::SRInfo2' },
+    }],
     0x005d => { #JD/PH
         # (used by all Pentax DSLR's except *istD and *istDS until firmware 2.0 - PH)
@@ -1537,5 +2176,5 @@
         # of test images shot in the factory. (But my new K-5 started at 1 - PH)
         # This count includes shutter actuations even if they don't result in a
-        # recorded image (ie. manual white balance frame or digital preview), but
+        # recorded image (eg. manual white balance frame or digital preview), but
         # does not include actuations due to Live View or video recording - PH
         Name => 'ShutterCount',
@@ -1555,4 +2194,5 @@
         ValueConvInv => '$val',
     },
+    # 0x005e -
     0x0060 => { #PH (K-5)
         Name => 'FaceInfo',
@@ -1560,5 +2200,29 @@
         SubDirectory => { TagTable => 'Image::ExifTool::Pentax::FaceInfo' },
     },
-    # 0x0062 - int16u: 1 (K10D,K200D,K-m,K2000), 3 (K20D), 4 (K-7), 5 (K-x), 6 (645D), 7 (K-r), 8 (K-5)
+    0x0062 => { #forum4803
+        Name => 'RawDevelopmentProcess',
+        Condition => '$$self{Make} =~ /^(PENTAX|RICOH)/', # rules out Kodak, which also use this tag
+        Writable => 'int16u',
+        PrintConv => {
+            1 => '1 (K10D,K200D,K2000,K-m)',
+            3 => '3 (K20D)',
+            4 => '4 (K-7)',
+            5 => '5 (K-x)',
+            6 => '6 (645D)',
+            7 => '7 (K-r)',
+            8 => '8 (K-5,K-5II,K-5IIs)',
+            9 => '9 (Q)',
+            10 => '10 (K-01,K-30,K-50,K-500)',
+            11 => '11 (Q10)',
+            12 => '12 (MX-1,Q-S1,Q7)',
+            13 => '13 (K-3,K-3II)',
+            14 => '14 (645Z)',
+            15 => '15 (K-S1,K-S2)', #PH
+            16 => '16 (K-1)', #PH
+            17 => '17 (K-70)', #29
+            18 => '18 (KP)', #PH
+            19 => '19 (GR III)', #PH
+        },
+    },
     0x0067 => { #PH (K-5)
         Name => 'Hue',
@@ -1584,13 +2248,21 @@
         SubDirectory => { TagTable => 'Image::ExifTool::Pentax::AWBInfo' },
     },
-    0x0069 => { #PH (K20D; K-5 highlights only)
+    0x0069 => { #PH (K20D, K-5, K-01 highlights only)
         Name => 'DynamicRangeExpansion',
+        Notes => q{
+            called highlight correction by Pentax for the K20D, K-5, K-01 and maybe
+            other models
+        },
         Writable => 'undef',
         Format => 'int8u',
         Count => 4,
-        PrintConv => {
-            '0 0 0 0' => 'Off',
-            '1 0 0 0' => 'On',
-        },
+        PrintConv => [{
+            0 => 'Off',
+            1 => 'On',
+        },{
+            0 => 0,
+            1 => 'Enabled', # (K-01)
+            2 => 'Auto', # (K-01)
+        }],
     },
     0x006b => { #PH (K-5)
@@ -1739,4 +2411,5 @@
         DataMember => 'FacesDetected',
         RawConv => '$val =~ / (\d+)/ and $$self{FacesDetected} = $1; $val',
+        # (the K-3 reports "On" even in phase-detect focus modes)
         PrintConv => [
             '$val ? "On ($val faces max)" : "Off"',
@@ -1757,5 +2430,5 @@
     # 0x0078 - int16u[2]: '0 0' (K-5,K-7,K-r,K-x)
     0x0079 => { #PH
-        Name => 'ShadowCompensation',
+        Name => 'ShadowCorrection',
         Writable => 'int8u',
         Count => -1,
@@ -1765,8 +2438,10 @@
             0 => 'Off',
             1 => 'On',
+            2 => 'Auto 2', # (NC, WG-3)
             '0 0' => 'Off',
             '1 1' => 'Weak',
             '1 2' => 'Normal',
             '1 3' => 'Strong',
+            '2 4' => 'Auto', # (K-01)
         },
     },
@@ -1779,4 +2454,5 @@
             '2 0' => 'Standard',
             '3 0' => 'Fast',
+            # '1 108' - seen for GR III
         },
     },
@@ -1801,5 +2477,10 @@
         SubDirectory => { TagTable => 'Image::ExifTool::Pentax::LensCorr' },
     },
-    # 0x007e - int32u: 15859,15860,15864,15865,16315 (K-5 PEF/DNG only) - PH
+    0x007e => { #IB
+        Name => 'WhiteLevel', # (with black level already subtracted)
+        Writable => 'int32u',
+        # 15859,15860,15864,15865,16315 (K-5 PEF/DNG only) - PH
+        # 3934, 3935 (Q DNG) - PH
+    },
     0x007f => { #PH (K-5)
         Name => 'BleachBypassToning',
@@ -1807,5 +2488,6 @@
         PrintConvColumns => 2,
         PrintConv => {
-            65535 => 'Off',
+            65535 => 'n/a', #31
+            0 => 'Off', #31
             1 => 'Green',
             2 => 'Yellow',
